/*
 * Copyright (C) 2009 Johan Stenarson
 * See accompanying file, LICENSE, for license information 
 */

if(typeof BUBBAMON === 'undefined') {
    var BUBBAMON = {}
}

BUBBAMON.PasswordManager = function(name) 
{
    this.HOSTNAME = 'chrome://bubbamon';
    this.HTTPREALM = 'Bubba Login';
    this.username = name;
    
    // Test what kind of password manager we're dealing with
    if("@mozilla.org/passwordmanager;1" in Components.classes) {
        this.passwordManager = Components.classes["@mozilla.org/passwordmanager;1"]
            .getService(Components.interfaces.nsIPasswordManager);

        this.get = function() {
            var e = this.passwordManager.enumerator;
            while (e.hasMoreElements()) {
                try {
                    // get an nsIPassword object out of the password manager.
                    // This contains the actual password...
                    var pass = e.getNext().QueryInterface(Components.interfaces.nsIPassword);
                    if (pass.host == "chrome://bubbamon" && pass.user == this.username) {
                        return(pass.password);
                    }
                } catch (ex) {
                    alert(ex.name + "\n" + ex.message);
                }
            }
        }

        this.set = function(password) {
            // For some reason, I have to remove user before adding a new password
            // or the password will only be used in this session and not being saved.
            try {
                this.passwordManager.removeUser(this.HOSTNAME, this.username);
            }
            catch(ex) {}

            // This is secret, store in password manager instead of clear text preferences.
            try {
                this.passwordManager.addUser(this.HOSTNAME, this.username, password);
            }
            catch(ex) {
                alert(ex.name + "\n" + ex.message);
            }
        }
    } else {
        this.loginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);

        this.get = function() {
            try {
                var logins = this.loginManager.findLogins({}, this.HOSTNAME, null, this.HTTPREALM);
                for(var i = 0; i < logins.length; i++) {
                    if(logins[i].username == this.username) {
                        return logins[i].password;
                    }
                }
            }
            catch(ex) {
                alert(ex.name + "\n" + ex.message);
            }
        }

        this.set = function(password) {
            try {
                var logins = this.loginManager.findLogins({}, this.HOSTNAME, null, this.HTTPREALM)

                    for(var i=0; i < logins.length; i++) {
                        if(logins[i].username == this.username) {
                            this.loginManager.removeLogin(logins[i]);
                        }
                    }

                var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",
                        Components.interfaces.nsILoginInfo, "init");
                var loginInfo = new nsLoginInfo(this.HOSTNAME, null, this.HTTPREALM, this.username, password, "", "");
                this.loginManager.addLogin(loginInfo);
            }
            catch(ex) {
                alert(ex.name + "\n" + ex.message);
            }
        }

    }
}
